<?php

namespace App\Http\Controllers\V1;

use App\Events\CardCertifiedEvent;
use App\Events\ExampleEvent;
use App\Handlers\BaseBikeControl;
use App\Handlers\BikeControl;
use App\Handlers\BikeHandler;
use App\Handlers\CheckAreaHandler;
use App\Handlers\ConvertHandler;
use App\Jobs\CheckRedOrderJob;
use App\Jobs\SendSMSBikeTemporaryWaitOverThirtyJob;
use App\Maps\CacheMap;
use App\Models\Bike;
use App\Models\InviteNewUser;
use App\Models\Parking;
use App\Models\Parkings;
use App\Models\RefundLog;
use App\Models\User;
use App\Models\WalletLog;
use App\Repositories\AreaRepository;
use App\Repositories\BikeRepository;
use App\Repositories\LocationLogRepository;
use App\Repositories\RefundLogRepository;
use App\Repositories\UserRepository;
use App\Transformers\BikeMeadTransformer;
use App\Transformers\BikeTransformer;
use App\Transformers\UserTransformer;
use Carbon\Carbon;
use Dingo\Api\Http\Request;
use GatewayClient\Gateway;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Event;
use Illuminate\Support\Facades\Log;
use Tymon\JWTAuth\Facades\JWTAuth;
use Illuminate\Support\Facades\Redis;
use Illuminate\Support\Facades\Cache;

/**
 * 测试模块
 * Class ExampleController
 * @package App\Http\Controllers\V1
 */
class ExampleController extends BaseController
{
    protected $userRepository;

    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct(UserRepository $userRepository)
    {
        $this->userRepository = $userRepository;
    }

    /**
     * @param Request $request
     * @return \Dingo\Api\Http\Response|string
     * User: Mead
     */
    public function index(Request $request)
    {
        $user = $this->userRepository->byIdGetModel(1);
        if (is_null($user)) {
            $this->response->errorNotFound('no data');
            return '';
        }
        return $this->response->item($user, UserTransformer::class);
    }

    public function orderRefund()
    {
//        $orders = Order::where('pay_status', Order::PAY_STATUS_OK)->whereDate('pay_time', Carbon::parse('-1 day')->toDateString())->get();
//        $payment = app('wechat.payment'); // 微信支付
//        foreach ($orders as $order) {
//            $result = $payment->refund->byOutTradeNumber($order->no, $order->no, wechat_fee($order->pay_money), wechat_fee($order->pay_money), [
//                // 可在此处传入其他参数，详细参数见微信支付文档
//                'refund_desc' => '退支付金额'
//            ]);
//        }
//        echo 'ok';
    }

    public function batterOpen(Request $request, BikeRepository $bikeRepository)
    {
//        $bike_no = $request->get('bike_no');
//        $box_no = $bikeRepository->byNoGetBoxNO($bike_no);
//        BikeControl::openBatteryLock($box_no);
//        return [
//            'status' => true
//        ];
    }

    public function batterClose(Request $request, BikeRepository $bikeRepository)
    {
//        $bike_no = $request->get('bike_no');
//        $box_no = $bikeRepository->byNoGetBoxNO($bike_no);
//        BikeControl::closeBatteryLock($box_no);
//        return [
//            'status' => true
//        ];
    }

    public function bikeClose(Request $request, BikeRepository $bikeRepository)
    {
//        $bike_no = $request->get('bike_no');
//        $box_no = $bikeRepository->byNoGetBoxNO($bike_no);
//        BikeControl::closeLock($box_no);
//        return [
//            'status' => true
//        ];
    }

    public function bikeOpen(Request $request, BikeRepository $bikeRepository)
    {
//        $bike_no = $request->get('bike_no');
//        $box_no = $bikeRepository->byNoGetBoxNO($bike_no);
//        BikeControl::openLock($box_no);
//        return [
//            'status' => true
//        ];
    }

    public function bikeBell(Request $request, BikeRepository $bikeRepository)
    {
        $bike_no = $request->get('bike_no');
        $box_no = $bikeRepository->byNoGetBoxNO($bike_no);
//        BikeControl::bellBike($box_no);
        (new BaseBikeControl($box_no))::bellBike();
        return [
            'status' => true
        ];
    }

    public function bikeInfo(Request $request, BikeRepository $bikeRepository)
    {
//        $bike_no = $request->get('bike_no');
//        $info = $bikeRepository->byBikeNo($bike_no);
//        Gateway::$registerAddress = '127.0.0.1:1238';
//        return [
//            'battery_power' => $info->battery_power,
//            'is_online' => Gateway::isUidOnline($info->box_no),
//            'lists' => Gateway::getAllUidList(),
//            'count' => Gateway::getAllClientCount(),
//            'bike_no' => $info->bike_no,
//            'box_no' => $info->box_no,
//        ];
    }

    public function test(Request $request, BikeRepository $bikeRepository, LocationLogRepository $locationLogRepository, AreaRepository $areaRepository, RefundLogRepository $refundLogRepository)
    {
//        $bike_no = '10010010752';
//        $bike = $bikeRepository->byBikeNo($bike_no);
//
//        return $this->response->item($bike, BikeMeadTransformer::class);


//        $user = User::query()->find(7);
//        $auth = $user->auth;
//        //超期退款
//        $payment = app('wechat.payment'); // 微信支付
//        $result = $payment->redpack->sendMiniprogramNormal([
//            'mch_billno' => RefundLog::makeNo(),
//            'send_name' => '未来GO',
//            're_openid' => $auth['credential'],
//            'total_amount' => wechat_fee(1),  //单位为分，不小于100
//            'wishing' => '退还超期押金',
//            'act_name' => '退还超期押金',
//            'remark' => '退还超期押金',
//        ]);
//        dd($result);
//        $refund->type = RefundLog::TYPE_RED_PACKET;
//        $refund->save();
//
//        $this->dispatch(new CheckRedOrderJob($refund->id, Carbon::now()->addMinutes(1)));
//        $this->dispatch(new CheckRedOrderJob($refund->id, Carbon::now()->addMinutes(5)));
//        $this->dispatch(new CheckRedOrderJob($refund->id, Carbon::now()->addMinutes(10)));
//        $this->dispatch(new CheckRedOrderJob($refund->id, Carbon::now()->addHours(6)));
//        if ($result['return_code'] === 'SUCCESS' && $result['result_code'] === 'SUCCESS') {
//            $order->is_refund = DepositOrder::REFUND_OK;
//            $order->save();
//        }
//        $ss = php2js($result);
//        Log::error("
//                        ********红包1*************
//                        result: {$ss}
//                        ");
    }

    public function check()
    {
        return $this->success();
    }

    public function token()
    {
        $user = $this->userRepository->byIdGetModel(3);
        $token = JWTAuth::fromUser($user);
        return $this->response->array([
            'token' => 'Bearer ' . $token,
            'ttl' => Carbon::now()->addMinute(JWTAuth::factory()->getTTL())->getTimestamp()
        ]);
    }
}
